Package: hyperdraw
Version: 1.64.0
Depends: R (>= 2.9.0)
Imports: methods, grid, graph, hypergraph, Rgraphviz, stats4
SystemRequirements: graphviz
Title: Visualizing Hypergaphs
Author: Paul Murrell
Maintainer: Paul Murrell <p.murrell@auckland.ac.nz>
Description: Functions for visualizing hypergraphs.
License: GPL (>= 2)
Collate: AllClasses.R affine.R draw.R graphBPH.R grid.R hypergraph.R
        legacy.R node.R RagraphBPH.R
biocViews: Visualization, GraphAndNetwork
git_url: https://git.bioconductor.org/packages/hyperdraw
git_branch: RELEASE_3_23
git_last_commit: ad9ee55
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:28:39 UTC; biocbuild
Built: R 4.6.0; ; 2026-04-29 04:46:43 UTC; unix

# Converting a 'hypergraph' package "Hypergraph" into a "graphBPH"

setMethod("graphBPH",
          signature(graph="Hypergraph", edgeNodePattern="missing"),
          function(graph, edgeNodePattern, ...) {
              hEdges <- hyperedges(graph)
              nodes <- nodes(graph)
              # Only valid for Hypergraph with all Hyperedges
              # DirectedHyperedges
              if (!all(sapply(hEdges, is, "DirectedHyperedge")))
                  stop("All hyperedges must be directed hyperedges")
              # Convert Hypergraph to graphNEL
              hEdgeNames <- hyperedgeLabels(graph)
              if (is.null(hEdgeNames)) 
                  hEdgeNames <- as.character(1:length(hEdges))
              if (any(hEdgeNames %in% nodes)) 
                  stop("hyperedge names must be distinct from node names")
              gnelNodes <- c(nodes, hEdgeNames)
              edgeList <- vector("list", length(gnelNodes))
              names(edgeList) <- gnelNodes
              for (i in 1:length(hEdges)) {
                  # Edges from this edge-node to other nodes
                  hename <- hEdgeNames[i]
                  newEdges <- hypergraph::tail(hEdges[[i]])
                  if (is.null(edgeList[[hename]])) {
                      edgeList[[hename]] <-
                          list(edges=newEdges)
                  } else {
                      edgeList[[hename]] <-
                          list(edges=c(edgeList[[hename]]$edges, newEdges))
                  }
                  # Edges from other nodes to this edge-node
                  headNodes <- hypergraph::head(hEdges[[i]])
                  headList <- lapply(headNodes, list, edges=hEdgeNames[i])
                  for (j in 1:length(headList)) {
                      hename <- headNodes[j]
                      if (is.null(edgeList[[hename]])) {
                          edgeList[[hename]] <- headList[[j]]
                      } else {
                          edgeList[[hename]] <-
                              list(edges=c(edgeList[[hename]]$edges,
                                     headList[[j]]$edges))
                      }
                  }
              }
              gnel <- new("graphNEL", nodes=gnelNodes,
                          edgeL=edgeList, edgemode="directed")
              # Standard initialization
              new("graphBPH", gnel,
                  edgeNodePattern=paste(paste("^", hEdgeNames, "$", sep=""),
                    collapse="|", sep=""))
          })

# This needs to disappear once R 2.11.0 is out

drawCurveOLD <- function(start, end, xy, dir, incoming, arr, rag) {
    # Calculate control points based on start and end node locations
    sx <- xy$x[start]
    sy <- xy$y[start]
    ex <- xy$x[end]
    ey <- xy$y[end]
    tempCP <- calcControlPoints(sx, sy, ex, ey, dir, incoming)
    # Use those to calculate "real" start/end (one of which will
    # be the *edge* of a node)
    if (incoming) {
        angle <- atan2(tempCP[2] - sy, tempCP[1] - sx)
        sx <- convertX(grobX(grid.get(start), angle/pi*180),
                       "native", valueOnly=TRUE)
        sy <- convertY(grobY(grid.get(start), angle/pi*180),
                       "native", valueOnly=TRUE)
    } else {
        angle <- atan2(tempCP[4] - ey, tempCP[3] - ex)
        ex <- convertX(grobX(grid.get(end), angle/pi*180),
                       "native", valueOnly=TRUE)
        ey <- convertY(grobY(grid.get(end), angle/pi*180),
                       "native", valueOnly=TRUE)
    }
    finalCP <- calcControlPoints(sx, sy, ex, ey, dir, incoming)
    lwd <- edgeData(rag, start, end, "lwd")
    if (is.na(lwd)) {
        lwd <- 1
    } 
    col <- edgeData(rag, start, end, "color")
    if (is.na(col)) {
        col <- "black"
    }
    grid.bezier(unit(c(sx, finalCP[1], finalCP[3], ex), "native"),
                unit(c(sy, finalCP[2], finalCP[4], ey), "native"),
                arrow=arr, gp=gpar(col=col, fill=col, lwd=lwd))
}

################
# This stuff should migrate to the 'grid' package

################
# Bezier curves

# X-Spline approx to Bezier
Ms <- 1/6*rbind(c(1, 4, 1, 0),
                c(-3, 0, 3, 0),
                c(3, -6, 3, 0),
                c(-1, 3, -3, 1))
Msinv <- solve(Ms)
# Bezier control matrix
Mb <- rbind(c(1, 0, 0, 0),
            c(-3, 3, 0, 0),
            c(3, -6, 3, 0),
            c(-1, 3, -3, 1))

splinePoints <- function(xb, yb) {
    xs <- Msinv %*% Mb %*% xb
    ys <- Msinv %*% Mb %*% yb
    list(x=xs, y=ys)
}

grid.bezier <- function(x, y, arrow=NULL, gp=NULL) {
    if (length(x) != 4 || length(y) != 4)
        stop("Must have exactly 4 control points")
    xx <- convertX(x, "inches", valueOnly=TRUE)
    yy <- convertY(y, "inches", valueOnly=TRUE)
    sp <- splinePoints(xx, yy)
    grid.xspline(sp$x, sp$y, default.units="inches",
                 shape=1, repEnds=FALSE,
                 arrow=arrow, gp=gp)
}

bezierPoints <- function(x, y) {
    xx <- convertX(x, "inches", valueOnly=TRUE)
    yy <- convertY(y, "inches", valueOnly=TRUE)
    sp <- splinePoints(xx, yy)
    xsplinePoints(xsplineGrob(sp$x, sp$y, default.units="inches",
                              shape=1, repEnds=FALSE))
}

###################
# Initialisation

# MUST supply a graph and an edgeNodePattern when create a graphBPH
setMethod("initialize", "graphBPH",
          function(.Object,
                   graph,
                   edgeNodePattern,
                   ...) {
              
              # Calculate the sets of normal nodes and edge nodes
              nodes <- nodes(graph)
              edgeNodeIndex <- grep(edgeNodePattern, nodes)
              normalNodes <- nodes[-edgeNodeIndex]
              edgeNodes <- nodes[edgeNodeIndex]

              # Calculate which nodes enter or leave each edgeNode
              edges <- edges(graph)
              edgeNodeOutgoing <- edges[edgeNodes]
              edgeNodeIncoming <- inEdges(edgeNodes, graph)

              # Fill the slots of the object
              .Object@graph <- graph
              .Object@edgeNodePattern <- edgeNodePattern
              .Object@nodes <- normalNodes
              .Object@edgeNodes <- edgeNodes
              .Object@edgeNodeIO <- list(incoming=edgeNodeIncoming,
                                         outgoing=edgeNodeOutgoing)
              
              validGraphBPH(.Object)
          })

# Convenience
setGeneric("graphBPH",
           function(graph, edgeNodePattern, ...) {
               standardGeneric("graphBPH")
           })

setMethod("graphBPH",
          signature(graph="graphNEL", edgeNodePattern="character"),
          function(graph, edgeNodePattern, ...) {
              new("graphBPH", graph, edgeNodePattern)
          })

###################
# Validation

validEdgeDest <- function(dest, validDest) {
    all(dest %in% validDest)
}

# Check for a valid graphBPH object
validGraphBPH <- function(obj) {
    # graphNEL must be "directed"
    # if (edgemode(obj@graph) != "directed")
    #     stop("Must be a directed graph")
    
    # Check that ALL edges are between
    # an "edge node" and a "normal node"
    edges <- edges(obj@graph)
    
    if (!all(sapply(edges[obj@nodes], validEdgeDest, obj@edgeNodes)) ||
        !all(sapply(edges[obj@edgeNodes], validEdgeDest, obj@nodes)))
        stop("All edges must be between a normal node and an edge node")
    
    obj
}


###################
# Plot method

setMethod("plot",
          signature(x="graphBPH", y="ANY"),
          function(x, y, layoutType="dot", ..., newpage=TRUE) {
              # Convert the graphNEL to an Ragraph
              # and lay it out
              # (this uses Rgraphviz)
              # NOTE:  '...' args are passed to graphLayout()
              # (which passes them to agopen())
              ragBPH <- graphLayout(x, layoutType=layoutType, ...)
              drawRagraphBPH(ragBPH, newpage)
          })
              
          
###################
# Print method ?

# Code for "node" grobs

node <- function(label, x=.5, y=.5,
                 shape="plain",  
                 margin=unit(1, "mm"),
                 name=label, gp=NULL) {
    lab <- textGrob(label, x, y, gp=gp, name="label")
    if (shape == "circle") {
        box <- circleGrob(x, y, r=0.5*grobWidth(lab) + margin, name="box",
                         gp=gpar(fill="grey90"))
    } else if (shape == "box") {
        box <- rectGrob(x, y,
                        width=grobWidth(lab) + margin,
                        height=grobHeight(lab) + margin,
                        name="box", gp=gpar(fill="grey90"))        
    } else { # plain
        box <- rectGrob(x, y,
                        width=grobWidth(lab) + 2*margin,
                        height=grobHeight(lab) + 2*margin,
                        name="box", gp=gpar(col=NA, fill=NA))
    }
    gTree(children=gList(box, lab), name=name, cl="node")
}

grobX.node <- function(x, theta) {
    grobX(getGrob(x, "box"), theta)
}

grobY.node <- function(x, theta) {
    grobY(getGrob(x, "box"), theta)
}

###################
# Affine transformations
translateM <- function(tx, ty) {
    rbind(c(1, 0, tx),
          c(0, 1, ty),
          c(0, 0, 1))
}

translate <- function(x, y, tx, ty) {
    temp <- translateM(tx, ty) %*% cbind(c(x, y, 1))
    temp[1:2]/temp[3]
}

rotateM <- function(angle) {
    ca <- cos(angle)
    sa <- sin(angle)
    rbind(c(ca, -sa, 0),
          c(sa, ca, 0),
          c(0, 0, 1))
}

rotate <- function(x, y, angle) {
    temp <- rotateM(angle) %*% cbind(c(x, y, 1))
    temp[1:2]/temp[3]    
}

transform <- function(x, y, t) {
    t %*% cbind(c(x, y, 1))
}

# Turn graphLayout() into a generic

setGeneric("graphLayout",
           function(graph, layoutType, ...) {
               standardGeneric("graphLayout")
           })

setMethod("graphLayout",
          signature(graph="Ragraph"),
          Rgraphviz::graphLayout)

# Method for graphBPH to create an RagraphBPH

layoutGraphBPH <- function(graph, layoutType="dot", ...) {
    rag <- agopen(graph@graph, name="rag",
                  layoutType=layoutType, ...)
    new("RagraphBPH", 
        graph=rag,
        allNodes=nodes(graph@graph),
        nodes=graph@nodes,
        edgeNodes=graph@edgeNodes,
                  edgeNodeIO=graph@edgeNodeIO)
}

setMethod("graphLayout",
          signature(graph="graphBPH", layoutType="missing"),
          function(graph, layoutType, ...) {
              layoutGraphBPH(graph, ...)
          })

setMethod("graphLayout",
          signature(graph="graphBPH", layoutType="character"),
          function(graph, layoutType, ...) {
              layoutGraphBPH(graph, layoutType, ...)
          })

drawRagraphBPH <- function(x, newpage) {
    if (newpage) {
        grid.newpage()
    }
    nodes <- x@allNodes
    rag <- x@graph
              # (x, y) locations of all the nodes
              # The order is the same as the nodes in
              # the original graphNEL
    xy <- getNodeXY(rag)
    names(xy$x) <- nodes
    names(xy$y) <- nodes
              # For each edgeNode, what's the average angle at which
              # edges pass through?
    edgeNodeDir <- mapply(edgeNodeTangent,
                          x@edgeNodes,
                          x@edgeNodeIO$incoming,
                          x@edgeNodeIO$outgoing,
                          MoreArgs=list(xy=xy))
    bb <- boundBox(rag)
    pushViewport(viewport(xscale=c(getX(botLeft(bb)), getX(upRight(bb))),
                          yscale=c(getY(botLeft(bb)), getY(upRight(bb)))))
    lapply(x@nodes, drawNode, xy, rag)
              lapply(x@edgeNodes, drawEdgeNode, xy, x@edgeNodeIO)
    lapply(edgeNames(rag), drawHyperEdge, xy, x@edgeNodes, edgeNodeDir, rag)
    lapply(x@edgeNodes, drawLabel, xy, x@edgeNodeIO, edgeNodeDir, rag)
              # Redraw main nodes (to cover bleeding edges)
    lapply(x@nodes, drawNode, xy, rag)
    popViewport()
}

setMethod("plot",
          signature(x="RagraphBPH"),
          function(x, y, newpage=TRUE, ...) {
              drawRagraphBPH(x, newpage)
          })

setMethod("graphDataDefaults<-",
          signature(self="RagraphBPH", attr="character", value="ANY"),
          function(self, attr, value) {
              graphDataDefaults(self@graph, attr) <- value
              self
          } )

setMethod("graphData<-",
          signature(self="RagraphBPH", attr="character", value="ANY"),
          function(self, attr, value) {
              graphData(self@graph, attr) <- value
              self
          })

setMethod("edgeDataDefaults<-",
          signature(self="RagraphBPH", attr="character", value="ANY"),
          function(self, attr, value) {
              edgeDataDefaults(self@graph, attr) <- value
              self
          } )

setMethod("edgeData<-",
          signature(self="RagraphBPH", from="character", to="character",
                    attr="character", value="ANY"),
          function(self, from, to, attr, value) {
              edgeData(self@graph, from, to, attr) <- value
              self
          })

setMethod("nodeDataDefaults<-",
          signature(self="RagraphBPH", attr="character", value="ANY"),
          function(self, attr, value) {
              nodeDataDefaults(self@graph, attr) <- value
              self
          } )

setMethod("nodeData<-",
          signature(self="RagraphBPH", n="character",
                    attr="character", value="ANY"),
          function(self, n, attr, value) {
              nodeData(self@graph, n, attr) <- value
              self
          })

####################
# A graphBPH is a graphNEL with certain additional constraints

# The nodes of a graphBPH are divided into two sets:
# normal nodes and "edge nodes"

# The 'edgeNodePattern' is a regular expression that is
# used to define the two node sets (based on the node names)

# The intention is that a graphBPH may not be modified once
# it has been created


setClass("graphBPH",
         representation(# Specified by user
                        graph="graphNEL",
                        edgeNodePattern="character",
                        # Derived from user-spec
                        nodes="character",
                        edgeNodes="character",
                        edgeNodeIO="list"))
                        

####################
# An RagraphBPH is an Ragraph with certain additional constraints

setClass("RagraphBPH",
         representation(graph="Ragraph",
                        allNodes="character",
                        nodes="character",
                        edgeNodes="character",
                        edgeNodeIO="list"))
                        

library(hyperdraw)

# Check graph validation

# Edges must be directed

badgnel.1 <- new("graphNEL",
                nodes=c("A", "R"),
                edgeL=list(
                  A=list(edges="R"),
                  R=list(edges="A")))
stopifnot(inherits(try(graphBPH(badgnel.1, "")), "try-error"))

# All edges must be between normal node and edge node
badgnel.2 <- new("graphNEL",
                 nodes=c("A", "B"),
                 edgeL=list(
                   A=list(edges="B"),
                   B=list(edges="A")),
                 edgemode="directed")
stopifnot(inherits(try(graphBPH(badgnel.2, "")), "try-error"))

# If it's a Hypergraph, all Hyperedges must be DirectedHyperedges

require(hypergraph)

badhg <- Hypergraph(c("A", "B"), list(Hyperedge(c("A", "B"))))
stopifnot(inherits(try(graphBPH(badhg)), "try-error"))

# Examples in man pages test simple examples that should work

#############
# All the nasty details about drawing

# 'xy' is a set of xy-locations for nodes

# 'rag' is an Ragraph object

edgeNodeTangent <- function(edgeNode, edgeNodeIncoming, edgeNodeOutgoing, xy) {
    # Calculate the average angle for all incoming and outgoing
    # edges
    # NOTE  that we do this by ...
    # - calculating all incoming and outgoing angles
    # - converting angles to x-y vectors (unit length)
    # - summing the x-y vectors
    # - then arctan of those averages
    nin <- length(edgeNodeIncoming)
    nout <- length(edgeNodeOutgoing)
    xin <- xy$x[edgeNode] - xy$x[edgeNodeIncoming]
    xout <- xy$x[edgeNodeOutgoing] - xy$x[edgeNode]
    yin <- xy$y[edgeNode] - xy$y[edgeNodeIncoming]
    yout <- xy$y[edgeNodeOutgoing] - xy$y[edgeNode]
    # Special case 1:  NO edges enter OR outgoing
    if (nin == 0 && nout == 0) {
        # No problem because no edges will be drawn
        # to or from this rnode
        NA 
    } else {
        # Special case 2:  NO edges incoming
        if (nin == 0) {
            angles <- atan2(yout, xout)
        # Special case 3:  NO edges outgoing
        } else if (nout == 0) {
            angles <- atan2(yin, xin)
        # Normal:  average in and out
        } else {    
            angles <- atan2(c(yin, yout), c(xin, xout))
        }
        dx <- cos(angles)
        dy <- sin(angles)
        atan2(sum(dy), sum(dx))
    }
}

# Draw a normal node
drawNode <- function(node, xy, rag) {
    margin <- eval(parse(text=nodeData(rag, node, "margin")))
    if (is.na(margin)) {
        margin <- unit(1, "mm")
    }
    shape <- nodeData(rag, node, "shape")
    if (is.na(shape)) {
        shape <- "plain"
    }
    cex <- nodeData(rag, node, "cex")
    if (is.na(cex)) {
        cex <- 1
    }
    col <- nodeData(rag, node, "color")
    if (is.na(col)) {
        col <- "black"
    }    
    grid.draw(node(node,
                   unit(xy$x[node], "native"),
                   unit(xy$y[node], "native"),
                   shape=shape,
                   margin=margin,
                   gp=gpar(cex=cex, col=col)))
}

drawEdgeNode <- function(edgeNode, xy, edgeNodeIO) {
    # If no incoming nodes, then draw a dot
    nin <- length(edgeNodeIO$incoming[[edgeNode]])
    if (nin == 0) {
        grid.circle(unit(xy$x[edgeNode], "native"),
                    unit(xy$y[edgeNode], "native"),
                    r=unit(.5, "mm"),
                    gp=gpar(fill="black"))
    }
}

drawLabel <- function(edgeNode, xy, edgeNodeIO, edgeNodeTangent, rag,
                      offset=unit(1, "mm")) {
    # If no incoming or outgoing nodes, then draw to the left
    nin <- length(edgeNodeIO$incoming[[edgeNode]])
    nout <- length(edgeNodeIO$outgoing[[edgeNode]])
    if (nin == 0 && nout == 0) {
        dir <- pi
    } else {
        # Determine location perpendicular to the
        # tangent that all edges pass through at this node
        dir <- edgeNodeTangent[[edgeNode]] + pi/2
        while (dir > 2*pi)
            dir <- dir - 2*pi
        while (dir < 0)
            dir <- dir + 2*pi
    }
    # Justify the text based on the direction
    hjust <- ifelse(dir > pi/2 && dir < 3*pi/2, 1, 0)
    vjust <- ifelse(dir > 0  && dir < pi, 0, 1)
    col <- nodeData(rag, edgeNode, "color")
    if (is.na(col)) {
        col <- "black"
    }    
    cex <- nodeData(rag, edgeNode, "cex")
    if (is.na(cex)) {
        cex <- 1
    }
    label <- nodeData(rag, edgeNode, "label")
    grid.text(label,
              unit(xy$x[edgeNode], "native") + cos(dir)*offset,
              unit(xy$y[edgeNode], "native") + sin(dir)*offset,
              hjust=hjust, vjust=vjust,
              gp=gpar(col=col, cex=cex))
}

# Given start and end points, calc intermediate control points
calcControlPoints <- function(sx, sy, ex, ey, dir, incoming) {
    dx <- ex - sx
    dy <- ey - sy
    # Angle of start -> end
    angle <- atan2(dy, dx)
    # Rotate end about start by -angle
    trans <- translateM(sx, sy) %*% rotateM(-angle) %*% translateM(-sx, -sy)
    newEnd <- transform(ex, ey, trans)
    # Add -angle to dir
    newDir <- dir - angle
    if (incoming) {
        snd <- sin(-newDir)
        cnd <- cos(-newDir)
    } else {
        snd <- sin(newDir)
        cnd <- cos(newDir)
    }
    # Distance between start and end
    D <- sqrt(dx^2 + dy^2)
    # Amount of that distance that we will use to position control points
    # (use more as the newDir points further away from start node)
    Dangle <- abs(newDir)
    while (Dangle > pi) Dangle <- pi*2 - Dangle
    Dfrac <- D/4 + (3*D/4)*tan(Dangle/4)
    # P2
    # If the tangent that this curve has to meet points "away" from the
    # start node, then make P2 at 90 degree angle to P3 about end node
    # (rather than mirroring P3 from start node)
    if (incoming && cnd < 0) {
        p2x <- sx - Dfrac*cnd
    } else {
        p2x <- sx + Dfrac*cnd
    }
    p2y <- sy + Dfrac*snd
    # P3
    if (!incoming && cnd < 0) { 
        p3x <- newEnd[1] + Dfrac*cnd
    } else {
        p3x <- newEnd[1] - Dfrac*cnd
    }
    p3y <- newEnd[2] + Dfrac*snd
    # Rotate P2 and P3 back
    invtrans <- solve(trans)
    p2Final <- transform(p2x, p2y, invtrans)
    p3Final <- transform(p3x, p3y, invtrans)
    c(p2Final[1:2], p3Final[1:2])
}

trimPts <- function(pts, start, end, fromStart) {
    node <- start
    ref <- 1
    step <- 1
    if (!fromStart) {
        node <- end
        step <- -1
        ref <- length(pts$x)
    }
    getAngle <- function(pts, ref) {
        dx <- convertX(pts$x[ref + step] - pts$x[ref], "inches",
                       valueOnly=TRUE)
        dy <- convertY(pts$y[ref + step] - pts$y[ref], "inches",
                       valueOnly=TRUE)
        # What is direction from start/end to point (start + i)/(end - i)?
        atan2(dy, dx)
    }        
    compareDist <- function(pts, node, ref) {
        dx <- convertX(pts$x[ref + step] - pts$x[ref], "inches",
                       valueOnly=TRUE)
        dy <- convertY(pts$y[ref + step] - pts$y[ref], "inches",
                       valueOnly=TRUE)
        angle <- getAngle(pts, ref)
        # What is the distance to the edge of the node in that direction?
        edx <- convertX(grobX(grid.get(node), angle/pi*180) - pts$x[ref],
                        "inches", valueOnly=TRUE)
        edy <- convertY(grobY(grid.get(node), angle/pi*180) - pts$y[ref],
                        "inches", valueOnly=TRUE)
        dist <- edx^2 + edy^2
        dist > (dx^2 + dy^2)
    }
    # Is that distance greater than the distance from start/end
    # to (start + i)/(end - i)?
    # FIXME: vectorize this!?
    while (compareDist(pts, node, ref)) {
        if (fromStart)
            step <- step + 1
        else
            step <- step - 1
    }
    newx <- grobX(grid.get(node), getAngle(pts, ref)/pi*180)
    newy <- grobY(grid.get(node), getAngle(pts, ref)/pi*180)
    if (fromStart) {
        list(x=unit.c(newx, pts$x[-(ref:(ref+step-1))]),
             y=unit.c(newy, pts$y[-(ref:(ref+step-1))]))
    } else {
        list(x=unit.c(pts$x[-(ref:(ref+step+1))], newx),
             y=unit.c(pts$y[-(ref:(ref+step+1))], newy))        
    }
}

drawCurve <- function(start, end, xy, dir, incoming, arr, rag) {
    # Calculate control points based on start and end node locations
    sx <- xy$x[start]
    sy <- xy$y[start]
    ex <- xy$x[end]
    ey <- xy$y[end]
    cp <- calcControlPoints(sx, sy, ex, ey, dir, incoming)
    # Calculate locations to draw lines through
    pts <- bezierPoints(unit(c(sx, cp[1], cp[3], ex), "native"),
                        unit(c(sy, cp[2], cp[4], ey), "native"))
    tpts <- trimPts(pts, start, end, incoming)
    lwd <- edgeData(rag, start, end, "lwd")
    if (is.na(lwd)) {
        lwd <- 1 # edgeDataDefaults(rag, "lwd")
    }
    col <- edgeData(rag, start, end, "color")
    if (is.na(col)) {
        col <- "black"
    }
    grid.lines(tpts$x, tpts$y, arrow=arr,
               gp=gpar(col=col, fill=col, lwd=lwd))
}

drawEdge <- function(start, end, xy, dir, incoming, arr, rabg) {
    # If using development version of R, make use of
    # new xsplinePoints() function
    if (as.numeric(R.version$major) > 2 ||
        (as.numeric(R.version$major) >= 2 &&
         as.numeric(R.version$minor) >= 11))
        drawCurve(start, end, xy, dir, incoming, arr, rabg)
    else
        drawCurveOLD(start, end, xy, dir, incoming, arr, rabg)
}

drawHyperEdge <- function(edge, xy, edgeNodes, edgeNodeDir, rag, eps=5) {
    start <- gsub("(^.+)~.+$", "\\1", edge)
    end <- gsub("^.+~(.+)$", "\\1", edge)
    incoming <- end %in% edgeNodes
    arrLoc <- graphData(rag, "arrowLoc")
    if (is.na(arrLoc))
        arrLoc <- "middle"
    if (incoming) {
        dir <- edgeNodeDir[[end]]
        if (arrLoc == "middle") {
            # Arrows drawn at edgeNodes
            arr <- arrow(length=unit(1.5, "mm"), type="closed")
        } else if (arrLoc == "both" || arrLoc == "start") {
            arr <- arrow(length=unit(1.5, "mm"), type="closed", ends="first")
        } else {
            arr <- NULL
        }
    } else {
        dir <- edgeNodeDir[[start]]
        if (arrLoc == "end" || arrLoc == "both") {
            arr <- arrow(length=unit(1.5, "mm"), type="closed")
        } else {
            arr <- NULL
        }
    }
    drawEdge(start, end, xy, dir, incoming, arr, rag)
}

\name{RagraphBPH-class}
\Rdversion{1.1}
\docType{class}
\alias{RagraphBPH}
\alias{RagraphBPH-class}
\alias{plot,RagraphBPH,ANY-method}
\alias{edgeDataDefaults<-,RagraphBPH,character,ANY-method}
\alias{edgeData<-,RagraphBPH,character,character,character,ANY-method}
\alias{nodeDataDefaults<-,RagraphBPH,character,ANY-method}
\alias{nodeData<-,RagraphBPH,character,character,ANY-method}
\alias{graphDataDefaults<-,RagraphBPH,character,ANY-method}
\alias{graphData<-,RagraphBPH,character,ANY-method}

\title{Class "RagraphBPH"}
\description{The purpose of this class is to represent a
  laid out version of a \code{graphBPH} object.
  The laying out is performed by the \pkg{Rgraphviz} package.
  This is an intermediate step in the process of drawing
  a \code{graphBPH} object. 
}
\section{Objects from the Class}{
  Objects of this class should be created via the
  \code{graphLayout()} function.
}
\section{Slots}{
  \describe{
    \item{\code{graph}:}{Object of class \code{Ragraph}.
      The laid out graph.}
    \item{\code{allNodes}:}{Object of class \code{character}.
      The names of all nodes in the graph.}
    \item{\code{nodes}:}{Object of class \code{character}.
      Records normal nodes in the graph.}
    \item{\code{edgeNodes}:}{Object of class \code{character}.
      Records edge-nodes in the graph. }
    \item{\code{edgeNodeIO}:}{Object of class \code{list}.
      Records which edges enter and exit each edge-node. }
  }
}
\section{Methods}{
  \describe{
    \item{plot}{\code{signature(x = "RagraphBPH", y = "ANY")}:
      draw a representation of the hypergraph where edges between
      normal nodes in the graph pass through an intermediate
      edge-node in a nice smooth curve. }
    \item{edgeDataDefaults<-}{\code{signature(self = "RagraphBPH",
        attr = "character", value = "ANY")}:
      set the default drawing attributes for all edges.}
    \item{edgeData<-}{\code{signature(self = "RagraphBPH",
        from = "character", to = "character", attr = "character",
        value = "ANY")}:
      set a specific drawing attribute for one or more edges. }
    \item{nodeDataDefaults<-}{\code{signature(self = "RagraphBPH",
        attr = "character", value = "ANY")}:
      set the default drawing attributes for all nodes.}
    \item{nodeData<-}{\code{signature(self = "RagraphBPH",
        n = "character", attr = "character", value = "ANY")}:
      set a specific attribute for one or more nodes. }
    \item{graphDataDefaults<-}{\code{signature(self = "RagraphBPH",
        attr = "character", value = "ANY")}:
      set the default drawing attributes for the graph.}
    \item{graphData<-}{\code{signature(self = "RagraphBPH",
        n = "character", attr = "character", value = "ANY")}:
      set a specific attribute for the graph. }
  }
}
\author{ Paul Murrell }
\seealso{
  \code{\link{graphLayout}},
  \code{\linkS4class{graphBPH}},
  and
  \code{\linkS4class{Ragraph}}
}
\examples{
nodes <- c(LETTERS[1:5], paste("R", 1:3, sep=""))
testgnel <- new("graphNEL",
                nodes=nodes,
                edgeL=list(
                  A=list(edges=c("R1", "R2")),
                  B=list(edges="R2"),
                  C=list(),
                  D=list(edges="R3"),
                  E=list(),
                  R1=list(edges="B"),
                  R2=list(edges=c("C", "D")),
                  R3=list(edges="E")),
                edgemode="directed")
testbph <- graphBPH(testgnel, "^R")
testrabph <- graphLayout(testbph)
edgeDataDefaults(testrabph, "lwd") <- 1
edgeData(testrabph, c("A", "R1"), c("R1", "B"), "lwd") <- c("3", 5)
edgeDataDefaults(testrabph, "color") <- "black"
edgeData(testrabph, c("A", "R1"), c("R1", "B"), "color") <- "red"
nodeDataDefaults(testrabph, "margin") <- 'unit(2, "mm")'
nodeDataDefaults(testrabph, "shape") <- "circle"
plot(testrabph)
graphDataDefaults(testrabph, "arrowLoc") <- "middle"
graphData(testrabph, "arrowLoc") <- "end"
plot(testrabph)
graphData(testrabph, "arrowLoc") <- "none"
plot(testrabph)
}
\keyword{classes}

\name{graphBPH}
\alias{graphBPH}
\alias{graphBPH,graphNEL,character-method}
\alias{graphBPH,Hypergraph,missing-method}
\title{Constructor for graphBPH objects}
\description{
  A convenience constructor for \code{\link{graphBPH-class}}
  objects. This is a generic function.
}
\usage{
graphBPH(graph, edgeNodePattern, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{graph}{Some form of graph that is to be converted into a
    \code{graphBPH} object.}
  \item{edgeNodePattern}{A regular expression used to distinguish
    between normal nodes and edge nodes.}
  \item{...}{ Potential arguments to other methods. }
}
\section{Methods}{
  \describe{
    \item{graphBPH}{
      \code{signature(graph = "graphNEL", edgeNodePattern = "character")}:
      create a \code{graphBPH} object from a (directed) \code{graphNEL}
      object. }
    \item{graphBPH}{
      \code{signature(graph = "Hypergraph", edgeNodePattern = "missing")}:
      create a \code{graphBPH} object from a \code{Hypergraph}
      object (where all \code{Hyperedges} are
      \code{DirectedHyperedges}). }
    }
}
\value{
  An object of class \code{\link{graphBPH-class}}
}
\references{
  Falcon, S. and Gentleman, R.
  \pkg{hypergraph}: A package providing hypergraph data structures.

  Gentleman, R. and Whalen, E. and Huber, W. and Falcon, S. 
\pkg{graph}: A package to handle graph data structures.
}
\author{Paul Murrell}
\seealso{
  \code{\link{graphBPH-class}}
}
\keyword{classes}

\name{graphBPH-class}
\Rdversion{1.1}
\docType{class}
\alias{graphBPH-class}
\alias{plot,graphBPH,ANY-method}
\alias{graphLayout,graphBPH,missing-method}
\alias{graphLayout,graphBPH,character-method}

\title{Class "graphBPH" }
\description{A bipartite representation of a hypergraph.
  The purpose of this class is to support visualization
  of the hypergraph;  it is not intended for analysis or manipulation
  of the hypergraph. }
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("graphBPH",
    graph, edgeNodePattern, ...)}.
  There is also a convenience function \code{graphBPH()}.
  
  A \code{graphBPH} object consists of a \code{graphNEL}
  object, which must obey some strict rules:
  \itemize{
    \item nodes in the graph are divided into two sets:
      normal nodes and edge-nodes,
    \item all edges in the graph
      must connect a normal node to an edge node,
    \item the graph must be a directed graph.
  }
  The \code{edgeNodePattern} is a regular expression that is
  used to define the set of edge-nodes.
}
\section{Slots}{
  \describe{
    \item{\code{graph}:}{Object of class \code{graphNEL}.  This graph
    must obey the constraints described above. }
  \item{\code{edgeNodePattern}:}{Object of class \code{character}.
    The regular expression used to define edge-nodes. }
  \item{\code{nodes}:}{Object of class \code{character}.
    Records which nodes in the graph are normal nodes. }
  \item{\code{edgeNodes}:}{Object of class \code{character}.
    Records which nodes in the graph are edge-nodes. }
    \item{\code{edgeNodeIO}:}{Object of class \code{list}.
      Records information about which edges enter and exit
      each edge-node.}
  }
}
\section{Methods}{
  \describe{
    \item{plot}{\code{signature(x = "graphBPH", y = "ANY")}:
      draw a representation of the hypergraph where edges between
      normal nodes in the graph pass through an intermediate
      edge-node in a nice smooth curve. }
    \item{graphLayout}{\code{signature(graph = "graphBPH",
          layoutType = "missing")}:
        convert the \code{graphBPH} object to a
        \code{RagraphBPH} object (using a default layout method).
      }
      \item{graphLayout}{\code{signature(graph = "graphBPH",
          layoutType = "character")}:
        convert the \code{graphBPH} object to a
        \code{RagraphBPH} object (using the specified layout method).
      }
    }
}
\references{
Gansner, E.R. and  and North, S.C. (1999)
 An open graph visualization system and its applications to software
  engineering,
\emph{Software - Practice and Experience}, 30:1203--1233.

Gentleman, R. and Whalen, E. and Huber, W. and Falcon, S. 
\pkg{graph}: A package to handle graph data structures.

Gentry, J. and Long, L. and Gentleman, R. and Falcon, S. and
Hahne, F. and Sarkar, D. and Hansen, K. 
\pkg{Rgraphviz}: Provides plotting capabilities for R graph objects.
}
\author{ Paul Murrell }
\seealso{
	\code{\link{agopen}},
	\code{\link{graphLayout}} and
	\code{\linkS4class{graphNEL}}
	\code{\linkS4class{RagraphBPH}}
}
\examples{
nodes <- c(LETTERS[1:5], paste("R", 1:3, sep=""))
testgnel <- new("graphNEL",
                nodes=nodes,
                edgeL=list(
                  A=list(edges=c("R1", "R2")),
                  B=list(edges="R2"),
                  C=list(),
                  D=list(edges="R3"),
                  E=list(),
                  R1=list(edges="B"),
                  R2=list(edges=c("C", "D")),
                  R3=list(edges="E")),
                edgemode="directed")
testbph <- graphBPH(testgnel, "^R")
plot(testbph)

# A Hypergraph equivalent
require(hypergraph)
dh1 <- DirectedHyperedge("A", "B", "R1")
dh2 <- DirectedHyperedge(c("A", "B"), c("C", "D"), "R2")
dh3 <- DirectedHyperedge("D", "E", "R3")
hg <- Hypergraph(LETTERS[1:5], list(dh1, dh2, dh3))
plot(graphBPH(hg))                 
}
\keyword{classes}

\name{graphLayout}
\alias{graphLayout}
\title{
  Layout a graph.
}
\description{
  This function is designed to layout a graph using
  the \pkg{Rgraphviz} package.
  The \pkg{hyperdraw} package makes this a generic function with a method for
  \code{graphBPH} objects.
  The function of the same name in the \pkg{Rgraphviz}
  package is used as a method for \code{Ragraph} objects.
}
\usage{
graphLayout(graph, layoutType, ...)
}
\arguments{
  \item{graph}{
    An   \code{graphBPH} object, which is to be laid out.
  }
  \item{layoutType}{
    The layout method (e.g., \code{dot} or \code{neato}).
  }
  \item{\dots}{
    These arguments will be passed to the \code{agopen()} function.
  }
}
\value{
  An \code{RagraphBPH} object.
}
\references{
Gansner, E.R. and  and North, S.C. (1999)
 An open graph visualization system and its applications to software
  engineering,
\emph{Software - Practice and Experience}, 30:1203--1233.

Gentry, J. and Long, L. and Gentleman, R. and Falcon, S. and
Hahne, F. and Sarkar, D. and Hansen, K. 
\pkg{Rgraphviz}: Provides plotting capabilities for R graph objects.
}
\author{
Paul Murrell
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  \code{\link{agopen}} and
  \code{\link{GraphvizLayouts}}
}
\examples{
nodes <- c(LETTERS[1:5], paste("R", 1:3, sep=""))
testgnel <- new("graphNEL",
                nodes=nodes,
                edgeL=list(
                  A=list(edges=c("R1", "R2")),
                  B=list(edges="R2"),
                  C=list(),
                  D=list(edges="R3"),
                  E=list(),
                  R1=list(edges="B"),
                  R2=list(edges=c("C", "D")),
                  R3=list(edges="E")),
                edgemode="directed")
testbph <- new("graphBPH", testgnel, "^R")
testrabph <- graphLayout(testbph)
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ dplot }
